/* Generated by CIL v. 1.5.1 */
/* print_CIL_Input is false */

#line 16 "include/asm-generic/int-ll64.h"
typedef unsigned char u8;
#line 19 "include/asm-generic/int-ll64.h"
typedef unsigned short u16;
#line 22 "include/asm-generic/int-ll64.h"
typedef unsigned int u32;
#line 25 "include/asm-generic/int-ll64.h"
typedef unsigned long long u64;
#line 162 "include/linux/types.h"
typedef u64 phys_addr_t;
#line 167 "include/linux/types.h"
typedef phys_addr_t resource_size_t;
#line 177 "include/linux/types.h"
struct __anonstruct_atomic_t_6 {
   int counter ;
};
#line 177 "include/linux/types.h"
typedef struct __anonstruct_atomic_t_6 atomic_t;
#line 183 "include/linux/types.h"
struct list_head {
   struct list_head *next ;
   struct list_head *prev ;
};
#line 426 "./arch/x86/include/asm/pgtable_types.h"
struct task_struct;
#line 20 "./arch/x86/include/asm/spinlock_types.h"
struct qspinlock {
   atomic_t val ;
};
#line 33 "include/asm-generic/qspinlock_types.h"
typedef struct qspinlock arch_spinlock_t;
#line 234 "include/linux/printk.h"
struct _ddebug {
   char const   *modname ;
   char const   *function ;
   char const   *filename ;
   char const   *format ;
   unsigned int lineno : 18 ;
   unsigned char flags ;
};
#line 687 "include/linux/list.h"
struct lockdep_map;
#line 55 "include/linux/debug_locks.h"
struct stack_trace {
   unsigned int nr_entries ;
   unsigned int max_entries ;
   unsigned long *entries ;
   int skip ;
};
#line 28 "include/linux/stacktrace.h"
struct lockdep_subclass_key {
   char __one_byte ;
};
#line 53 "include/linux/lockdep.h"
struct lock_class_key {
   struct lockdep_subclass_key subkeys[8U] ;
};
#line 59 "include/linux/lockdep.h"
struct lock_class {
   struct list_head hash_entry ;
   struct list_head lock_entry ;
   struct lockdep_subclass_key *key ;
   unsigned int subclass ;
   unsigned int dep_gen_id ;
   unsigned long usage_mask ;
   struct stack_trace usage_traces[13U] ;
   struct list_head locks_after ;
   struct list_head locks_before ;
   unsigned int version ;
   unsigned long ops ;
   char const   *name ;
   int name_version ;
   unsigned long contention_point[4U] ;
   unsigned long contending_point[4U] ;
};
#line 144 "include/linux/lockdep.h"
struct lockdep_map {
   struct lock_class_key *key ;
   struct lock_class *class_cache[2U] ;
   char const   *name ;
   int cpu ;
   unsigned long ip ;
};
#line 546 "include/linux/lockdep.h"
struct raw_spinlock {
   arch_spinlock_t raw_lock ;
   unsigned int magic ;
   unsigned int owner_cpu ;
   void *owner ;
   struct lockdep_map dep_map ;
};
#line 33 "include/linux/spinlock_types.h"
struct __anonstruct____missing_field_name_31 {
   u8 __padding[24U] ;
   struct lockdep_map dep_map ;
};
#line 33 "include/linux/spinlock_types.h"
union __anonunion____missing_field_name_30 {
   struct raw_spinlock rlock ;
   struct __anonstruct____missing_field_name_31 __annonCompField16 ;
};
#line 33 "include/linux/spinlock_types.h"
struct spinlock {
   union __anonunion____missing_field_name_30 __annonCompField17 ;
};
#line 76 "include/linux/spinlock_types.h"
typedef struct spinlock spinlock_t;
#line 39 "include/linux/osq_lock.h"
struct mutex {
   atomic_t count ;
   spinlock_t wait_lock ;
   struct list_head wait_list ;
   struct task_struct *owner ;
   void *magic ;
   struct lockdep_map dep_map ;
};
#line 29 "include/linux/types.h"
typedef _Bool bool;
#line 1 "<compiler builtins>"
__inline static long ldv__builtin_expect(long exp , long c ) ;
#line 142 "include/linux/printk.h"
extern int printk(char const   *  , ...) ;
#line 45 "include/linux/dynamic_debug.h"
extern void __dynamic_pr_debug(struct _ddebug * , char const   *  , ...) ;
#line 174 "include/linux/mutex.h"
extern void mutex_unlock(struct mutex * ) ;
#line 177
void ldv_mutex_unlock_6(struct mutex *ldv_func_arg1 ) ;
#line 50 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
__inline static long ldv__builtin_expect(long exp , long c ) 
{ 


  {
#line 52
  return (exp);
}
}
#line 18 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/dscv/ri/32_7a/arch/x86/mm/testmmiotrace.o.c.prepared"
extern void mutex_lock(struct mutex * ) ;
#line 21
void ldv_mutex_lock_5(struct mutex *ldv_func_arg1 ) ;
#line 26
void ldv_mutex_lock_lock(struct mutex *lock ) ;
#line 30
void ldv_mutex_unlock_lock(struct mutex *lock ) ;
#line 218 "include/linux/rcupdate.h"
extern void synchronize_sched(void) ;
#line 278 "include/linux/rcupdate.h"
__inline static void synchronize_rcu(void) 
{ 


  {
#line 280
  synchronize_sched();
#line 281
  return;
}
}
#line 181 "./arch/x86/include/asm/io.h"
extern void *ioremap_nocache(resource_size_t  , unsigned long  ) ;
#line 195
extern void iounmap(void volatile   * ) ;
#line 28 "include/asm-generic/iomap.h"
extern unsigned int ioread8(void * ) ;
#line 29
extern unsigned int ioread16(void * ) ;
#line 31
extern unsigned int ioread32(void * ) ;
#line 34
extern void iowrite8(u8  , void * ) ;
#line 35
extern void iowrite16(u16  , void * ) ;
#line 37
extern void iowrite32(u32  , void * ) ;
#line 73 "include/linux/mmiotrace.h"
__inline static int mmiotrace_printk(char const   *fmt  , ...) 
{ 


  {
#line 75
  return (0);
}
}
#line 12 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/dscv/ri/32_7a/arch/x86/mm/testmmiotrace.c"
static unsigned long mmio_address  ;
#line 17 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/dscv/ri/32_7a/arch/x86/mm/testmmiotrace.c"
static unsigned long read_far  =    4194560UL;
#line 22 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/dscv/ri/32_7a/arch/x86/mm/testmmiotrace.c"
static unsigned int v16(unsigned int i ) 
{ 


  {
#line 24
  return (i * 12U + 7U);
}
}
#line 27 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/dscv/ri/32_7a/arch/x86/mm/testmmiotrace.c"
static unsigned int v32(unsigned int i ) 
{ 


  {
#line 29
  return (i * 212371U + 13U);
}
}
#line 32 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/dscv/ri/32_7a/arch/x86/mm/testmmiotrace.c"
static void do_write_test(void *p ) 
{ 
  unsigned int i ;
  unsigned int tmp ;
  unsigned int tmp___0 ;

  {
#line 35
  printk("\016testmmiotrace: write test.\n");
#line 36
  mmiotrace_printk("Write test.\n");
#line 38
  i = 0U;
#line 38
  goto ldv_16059;
  ldv_16058: 
#line 39
  iowrite8((int )((u8 )i), p + (unsigned long )i);
#line 38
  i = i + 1U;
  ldv_16059: ;
#line 38
  if (i <= 255U) {
#line 40
    goto ldv_16058;
  } else {

  }
#line 41
  i = 1024U;
#line 41
  goto ldv_16062;
  ldv_16061: 
#line 42
  tmp = v16(i);
#line 42
  iowrite16((int )((u16 )tmp), p + (unsigned long )i);
#line 41
  i = i + 2U;
  ldv_16062: ;
#line 41
  if (i <= 5119U) {
#line 43
    goto ldv_16061;
  } else {

  }
#line 44
  i = 5120U;
#line 44
  goto ldv_16065;
  ldv_16064: 
#line 45
  tmp___0 = v32(i);
#line 45
  iowrite32(tmp___0, p + (unsigned long )i);
#line 44
  i = i + 4U;
  ldv_16065: ;
#line 44
  if (i <= 16383U) {
#line 46
    goto ldv_16064;
  } else {

  }

#line 51
  return;
}
}
#line 48 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/dscv/ri/32_7a/arch/x86/mm/testmmiotrace.c"
static void do_read_test(void *p ) 
{ 
  unsigned int i ;
  unsigned int errs[3U] ;
  unsigned int tmp ;
  unsigned int tmp___0 ;
  unsigned int tmp___1 ;
  unsigned int tmp___2 ;
  unsigned int tmp___3 ;
  unsigned int tmp___4 ;

  {
#line 51
  errs[0] = 0U;
#line 51
  tmp = 1U;
#line 51
  while (1) {
#line 51
    if (tmp >= 3U) {
#line 51
      break;
    } else {

    }
#line 51
    errs[tmp] = 0U;
#line 51
    tmp = tmp + 1U;
  }
#line 52
  printk("\016testmmiotrace: read test.\n");
#line 53
  mmiotrace_printk("Read test.\n");
#line 55
  i = 0U;
#line 55
  goto ldv_16073;
  ldv_16072: 
#line 56
  tmp___0 = ioread8(p + (unsigned long )i);
#line 56
  if (tmp___0 != i) {
#line 57
    errs[0] = errs[0] + 1U;
  } else {

  }
#line 55
  i = i + 1U;
  ldv_16073: ;
#line 55
  if (i <= 255U) {
#line 57
    goto ldv_16072;
  } else {

  }
#line 59
  i = 1024U;
#line 59
  goto ldv_16076;
  ldv_16075: 
#line 60
  tmp___1 = ioread16(p + (unsigned long )i);
#line 60
  tmp___2 = v16(i);
#line 60
  if (tmp___1 != tmp___2) {
#line 61
    errs[1] = errs[1] + 1U;
  } else {

  }
#line 59
  i = i + 2U;
  ldv_16076: ;
#line 59
  if (i <= 5119U) {
#line 61
    goto ldv_16075;
  } else {

  }
#line 63
  i = 5120U;
#line 63
  goto ldv_16079;
  ldv_16078: 
#line 64
  tmp___3 = ioread32(p + (unsigned long )i);
#line 64
  tmp___4 = v32(i);
#line 64
  if (tmp___3 != tmp___4) {
#line 65
    errs[2] = errs[2] + 1U;
  } else {

  }
#line 63
  i = i + 4U;
  ldv_16079: ;
#line 63
  if (i <= 16383U) {
#line 65
    goto ldv_16078;
  } else {

  }
#line 67
  mmiotrace_printk("Read errors: 8-bit %d, 16-bit %d, 32-bit %d.\n", errs[0], errs[1],
                   errs[2]);
#line 69
  return;
}
}
#line 71 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/dscv/ri/32_7a/arch/x86/mm/testmmiotrace.c"
static void do_read_far_test(void *p ) 
{ 


  {
#line 73
  printk("\016testmmiotrace: read far test.\n");
#line 74
  mmiotrace_printk("Read far test.\n");
#line 76
  ioread32(p + read_far);
#line 77
  return;
}
}
#line 79 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/dscv/ri/32_7a/arch/x86/mm/testmmiotrace.c"
static void do_test(unsigned long size ) 
{ 
  void *p ;
  void *tmp ;

  {
#line 81
  tmp = ioremap_nocache((resource_size_t )mmio_address, size);
#line 81
  p = tmp;
#line 82
  if ((unsigned long )p == (unsigned long )((void *)0)) {
#line 83
    printk("\vtestmmiotrace: could not ioremap, aborting.\n");
#line 84
    return;
  } else {

  }
#line 86
  mmiotrace_printk("ioremap returned %p.\n", p);
#line 87
  do_write_test(p);
#line 88
  do_read_test(p);
#line 89
  if (read_far != 0UL && size - 4UL > read_far) {
#line 90
    do_read_far_test(p);
  } else {

  }
#line 91
  iounmap((void volatile   *)p);
#line 92
  return;
}
}
#line 100 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/dscv/ri/32_7a/arch/x86/mm/testmmiotrace.c"
static void do_test_bulk_ioremapping(void) 
{ 
  void *p ;
  int i ;

  {
#line 105
  i = 0;
#line 105
  goto ldv_16094;
  ldv_16093: 
#line 106
  p = ioremap_nocache((resource_size_t )mmio_address, 4096UL);
#line 107
  if ((unsigned long )p != (unsigned long )((void *)0)) {
#line 108
    iounmap((void volatile   *)p);
  } else {

  }
#line 105
  i = i + 1;
  ldv_16094: ;
#line 105
  if (i <= 9) {
#line 107
    goto ldv_16093;
  } else {

  }
#line 112
  synchronize_rcu();
#line 113
  return;
}
}
#line 115 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/dscv/ri/32_7a/arch/x86/mm/testmmiotrace.c"
static int init(void) 
{ 
  unsigned long size ;

  {
#line 117
  size = read_far != 0UL ? 8388608UL : 16384UL;
#line 119
  if (mmio_address == 0UL) {
#line 120
    printk("\vtestmmiotrace: you have to use the module argument mmio_address.\n");
#line 121
    printk("\vtestmmiotrace: DO NOT LOAD THIS MODULE UNLESS YOU REALLY KNOW WHAT YOU ARE DOING!\n");
#line 122
    return (-6);
  } else {

  }
#line 125
  printk("\ftestmmiotrace: WARNING: mapping %lu kB @ 0x%08lx in PCI address space, and writing 16 kB of rubbish in there.\n",
         size >> 10, mmio_address);
#line 128
  do_test(size);
#line 129
  do_test_bulk_ioremapping();
#line 130
  printk("\016testmmiotrace: All done.\n");
#line 131
  return (0);
}
}
#line 134 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/dscv/ri/32_7a/arch/x86/mm/testmmiotrace.c"
static void cleanup(void) 
{ 
  struct _ddebug descriptor ;
  long tmp ;

  {
#line 136
  descriptor.modname = "testmmiotrace";
#line 136
  descriptor.function = "cleanup";
#line 136
  descriptor.filename = "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/dscv/ri/32_7a/arch/x86/mm/testmmiotrace.c";
#line 136
  descriptor.format = "unloaded.\n";
#line 136
  descriptor.lineno = 136U;
#line 136
  descriptor.flags = 0U;
#line 136
  tmp = ldv__builtin_expect((long )descriptor.flags & 1L, 0L);
#line 136
  if (tmp != 0L) {
#line 136
    __dynamic_pr_debug(& descriptor, "testmmiotrace: unloaded.\n");
  } else {

  }
#line 138
  return;
}
}
#line 159
void ldv_check_final_state(void) ;
#line 168
extern void ldv_initialize(void) ;
#line 171
extern void ldv_handler_precall(void) ;
#line 174
extern int nondet_int(void) ;
#line 177 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/dscv/ri/32_7a/arch/x86/mm/testmmiotrace.c"
int LDV_IN_INTERRUPT  ;
#line 180 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/dscv/ri/32_7a/arch/x86/mm/testmmiotrace.c"
void main(void) 
{ 
  int tmp ;
  int tmp___0 ;
  int tmp___1 ;

  {
#line 192
  LDV_IN_INTERRUPT = 1;
#line 201
  ldv_initialize();
#line 209
  ldv_handler_precall();
#line 210
  tmp = init();
#line 210
  if (tmp != 0) {
#line 211
    goto ldv_final;
  } else {

  }
#line 213
  goto ldv_16136;
  ldv_16135: 
#line 216
  tmp___0 = nondet_int();
#line 216
  switch (tmp___0) {
  default: ;
#line 218
  goto ldv_16134;
  }
  ldv_16134: ;
  ldv_16136: 
#line 213
  tmp___1 = nondet_int();
#line 213
  if (tmp___1 != 0) {
#line 215
    goto ldv_16135;
  } else {

  }

#line 232
  ldv_handler_precall();
#line 233
  cleanup();
  ldv_final: 
#line 236
  ldv_check_final_state();
#line 239
  return;
}
}
#line 57 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/dscv/ri/32_7a/arch/x86/mm/testmmiotrace.o.c.prepared"
void ldv_mutex_lock_5(struct mutex *ldv_func_arg1 ) 
{ 


  {
#line 60
  ldv_mutex_lock_lock(ldv_func_arg1);
#line 62
  mutex_lock(ldv_func_arg1);
#line 63
  return;
}
}
#line 65 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/dscv/ri/32_7a/arch/x86/mm/testmmiotrace.o.c.prepared"
void ldv_mutex_unlock_6(struct mutex *ldv_func_arg1 ) 
{ 


  {
#line 68
  ldv_mutex_unlock_lock(ldv_func_arg1);
#line 70
  mutex_unlock(ldv_func_arg1);
#line 71
  return;
}
}
#line 10 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
__inline static void ldv_error(void) 
{ 


  {
  ERROR: ;
#line 12
  goto ERROR;
}
}
#line 20 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
__inline static void ldv_stop(void) 
{ 


  {
  LDV_STOP: ;
#line 21
  goto LDV_STOP;
}
}
#line 25
extern int ldv_undef_int(void) ;
#line 30 "/home/cluser/ldv/inst/kernel-rules/verifier/rcv.h"
__inline static int ldv_undef_int_negative(void) 
{ 
  int ret ;
  int tmp ;

  {
#line 32
  tmp = ldv_undef_int();
#line 32
  ret = tmp;
#line 34
  if (ret >= 0) {
#line 34
    ldv_stop();
  } else {

  }
#line 36
  return (ret);
}
}
#line 7 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
bool ldv_is_err(void const   *ptr ) 
{ 


  {
#line 10
  return ((unsigned long )ptr > 2012UL);
}
}
#line 14 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
void *ldv_err_ptr(long error ) 
{ 


  {
#line 17
  return ((void *)(2012L - error));
}
}
#line 21 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
long ldv_ptr_err(void const   *ptr ) 
{ 


  {
#line 24
  return ((long )(2012UL - (unsigned long )ptr));
}
}
#line 28 "/home/cluser/ldv/inst/kernel-rules/kernel-model/ERR.inc"
bool ldv_is_err_or_null(void const   *ptr ) 
{ 
  bool tmp ;
  int tmp___0 ;

  {
#line 31
  if ((unsigned long )ptr == (unsigned long )((void const   *)0)) {
#line 31
    tmp___0 = 1;
  } else {
#line 31
    tmp = ldv_is_err(ptr);
#line 31
    if ((int )tmp) {
#line 31
      tmp___0 = 1;
    } else {
#line 31
      tmp___0 = 0;
    }
  }
#line 31
  return ((bool )tmp___0);
}
}
#line 8 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
static int ldv_mutex_lock  =    1;
#line 11 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_lock_interruptible_lock(struct mutex *lock ) 
{ 
  int nondetermined ;

  {
#line 16
  if (ldv_mutex_lock != 1) {
#line 16
    ldv_error();
  } else {

  }
#line 19
  nondetermined = ldv_undef_int();
#line 22
  if (nondetermined != 0) {
#line 25
    ldv_mutex_lock = 2;
#line 27
    return (0);
  } else {
#line 32
    return (-4);
  }
}
}
#line 37 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_lock_killable_lock(struct mutex *lock ) 
{ 
  int nondetermined ;

  {
#line 42
  if (ldv_mutex_lock != 1) {
#line 42
    ldv_error();
  } else {

  }
#line 45
  nondetermined = ldv_undef_int();
#line 48
  if (nondetermined != 0) {
#line 51
    ldv_mutex_lock = 2;
#line 53
    return (0);
  } else {
#line 58
    return (-4);
  }
}
}
#line 63 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_mutex_lock_lock(struct mutex *lock ) 
{ 


  {
#line 66
  if (ldv_mutex_lock != 1) {
#line 66
    ldv_error();
  } else {

  }
#line 68
  ldv_mutex_lock = 2;
#line 69
  return;
}
}
#line 72 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_trylock_lock(struct mutex *lock ) 
{ 
  int is_mutex_held_by_another_thread ;

  {
#line 77
  if (ldv_mutex_lock != 1) {
#line 77
    ldv_error();
  } else {

  }
#line 80
  is_mutex_held_by_another_thread = ldv_undef_int();
#line 83
  if (is_mutex_held_by_another_thread != 0) {
#line 86
    return (0);
  } else {
#line 91
    ldv_mutex_lock = 2;
#line 93
    return (1);
  }
}
}
#line 98 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_atomic_dec_and_mutex_lock_lock(atomic_t *cnt , struct mutex *lock ) 
{ 
  int atomic_value_after_dec ;

  {
#line 103
  if (ldv_mutex_lock != 1) {
#line 103
    ldv_error();
  } else {

  }
#line 106
  atomic_value_after_dec = ldv_undef_int();
#line 109
  if (atomic_value_after_dec == 0) {
#line 112
    ldv_mutex_lock = 2;
#line 114
    return (1);
  } else {

  }
#line 118
  return (0);
}
}
#line 123 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_mutex_is_locked_lock(struct mutex *lock ) 
{ 
  int nondetermined ;

  {
#line 127
  if (ldv_mutex_lock == 1) {
#line 130
    nondetermined = ldv_undef_int();
#line 133
    if (nondetermined != 0) {
#line 136
      return (0);
    } else {
#line 141
      return (1);
    }
  } else {
#line 147
    return (1);
  }
}
}
#line 152 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_mutex_unlock_lock(struct mutex *lock ) 
{ 


  {
#line 155
  if (ldv_mutex_lock != 2) {
#line 155
    ldv_error();
  } else {

  }
#line 157
  ldv_mutex_lock = 1;
#line 158
  return;
}
}
#line 163 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_usb_lock_device_lock(void) 
{ 


  {
#line 166
  ldv_mutex_lock_lock((struct mutex *)0);
#line 167
  return;
}
}
#line 170 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_usb_trylock_device_lock(void) 
{ 
  int tmp ;

  {
#line 172
  tmp = ldv_mutex_trylock_lock((struct mutex *)0);
#line 172
  return (tmp);
}
}
#line 176 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
int ldv_usb_lock_device_for_reset_lock(void) 
{ 
  int tmp ;
  int tmp___0 ;

  {
#line 178
  tmp___0 = ldv_undef_int();
#line 178
  if (tmp___0 != 0) {
#line 180
    ldv_mutex_lock_lock((struct mutex *)0);
#line 182
    return (0);
  } else {
#line 185
    tmp = ldv_undef_int_negative();
#line 185
    return (tmp);
  }
}
}
#line 189 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_usb_unlock_device_lock(void) 
{ 


  {
#line 191
  ldv_mutex_unlock_lock((struct mutex *)0);
#line 192
  return;
}
}
#line 196 "/home/cluser/mutilin/launch/work/current--X--arch--X--defaultlinux-4.2-rc1.tar.xz--X--32_7a--X--cpachecker/linux-4.2-rc1.tar.xz/csd_deg_dscv/154/dscv_tempdir/rule-instrumentor/32_7a/common-model/ldv_common_model.c"
void ldv_check_final_state(void) 
{ 


  {
#line 199
  if (ldv_mutex_lock != 1) {
#line 199
    ldv_error();
  } else {

  }
#line 203
  return;
}
}
